<?php
final class Mahacod {
	public $data = array();
	public $errors = array();
	
	public function __destruct() {
		$this->data = array();
		$this->errors = array();
	}
	
	/* Use in (self) */
	private function Connect() {
		$this->data['Config']['WSDL'] = "http://webservice.cod.local/cod.wsdl";		
		$soapClient = new SoapClient($this->data['Config']['WSDL'],array('login'=> $this->data['Config']['Username'],'password'=> $this->data['Config']['Password']));
		$this->data['Proxy'] = $soapClient;
	}
	/* Use in (Controller) */
	public function RegisterOrder($products, $customer, $data = array()) {
		$this->Connect();
		$product_array = array();
		foreach($products as $product) {
			$product_array[] = implode("^",array($product['mahacod_pid'],$product['Name'],$product['Weight'],$product['Price'],$product['Quantity']));
		}
		$customer['Orders'] = implode(";",$product_array);
		$customer['SendType'] = ($customer['SendType']=='sefareshi')?1:2;
		
		$Products = array();
		$Customer = (array)$customer;

		$this->data['Calls']['insert_order'] = $this->data['Proxy']->insert_order($Customer['FirstName'],
		$Customer['LastName'],
		$Customer['Telephone'],
		$Customer['Mobile'],
		$Customer['Email'],
		((isset($Customer['ZipCode'])&& !empty($Customer['ZipCode']))?$Customer['ZipCode']:'11'),
		$_SESSION['ostan_id'],
		$_SESSION['shahrestan_id'],
		$Customer['Address'],
		$Customer['Comment'],
		$Customer['SendType'],
		$Customer['Orders'],
		0,
		$Customer['Ip'],
		'');
		if (isset($this->data['Calls']['insert_order']->error_code) && is_numeric($this->data['Calls']['insert_order']->error_code)) {
			return array('OrderCode' => $this->data['Calls']['insert_order']->error_message);
		}else{
			return array('OrderCode' => $this->data['Calls']['insert_order']->order_code);
		}
	}
	/*********************************************************/
	public function get_post_price($data = array()) {
		$this->Connect();
		$this->data['Calls']['calculation_send_price'] = $this->data['Proxy']->calculation_send_price(
					$data['ostan_id']
					,$data['shahrestan_id']
					,(($data['SendType']=='sefareshi')?1:2)
					,$data['Weight']
					,$data['Total']);
		if (isset($this->data['Calls']['calculation_send_price']->error_code)) {
			return $this->data['Calls']['calculation_send_price']->error_message;
		} else {
			$send_price = $this->data['Calls']['calculation_send_price']->send_price+$this->data['Calls']['calculation_send_price']->maliyat+$this->data['Calls']['calculation_send_price']->khadamat+$this->data['Calls']['calculation_send_price']->codprice;
			return ((int)urldecode($send_price));
		}
	}
	/*********************************************************/
	public function get_ostan($corrent_ostan = '') {
		$ostan = array('41' => 'آذربایجان شرقی','44' => 'آذربایجان غربی','45' => 'اردبیل','31' => 'اصفهان','84' => 'ایلام','77' => 'بوشهر','26' => 'البرز','21' => 'تهران',
						'38' => 'چهارمحال و بختیاری','56' => 'خراسان جنوبی','51' => 'خراسان رضوی','58' => 'خراسان شمالی','61' => 'خوزستان','24' => 'زنجان','23' => 'سمنان',
						'54' => 'سیستان و بلوچستان','71' => 'فارس','28' => 'قزوین','25' => 'قم','87' => 'کردستان','34' => 'کرمان','83' => 'کرمانشاه','74' => 'کهکیلویه و بویراحمد',
						'17' => 'گلستان','13' => 'گیلان','66' => 'لرستان','15' => 'مازندران','86' => 'مرکزی','76' => 'هرمزگان','81' => 'همدان','35' => 'یزد');
		$html = '<select id="ostan" name="ostan">';
		$html .= '<option value="">-- لطفا انتخاب کنید --</option>';
		foreach($ostan as $key => $value) {
			$html .= '<option value="'.$key.'" '.($key == $corrent_ostan ? 'selected="selected"' : '').'>'.$value.'</option>';
		}
		$html .= '</select>';
		return $html;
	}
	/*********************************************************/
	public function get_shahrestan($corrent_shahrestan = '') {
		$html = '<script type="text/javascript" src="catalog/view/javascript/mahacod/city.js"></script>';
		$html .= '<input type="hidden" id="lastsh" value="'.$corrent_shahrestan.'">';
		$html .= '<select id="shahrestan" name="shahrestan">';
		$html .= '<option value="">-- لطفا انتخاب کنید --</option>';
		$html .= '</select>';
		return $html;
	}
	/*********************************************************/
	public function get_order_status($data = array()) {
		$data['rahgiri_code'] = isset($data['rahgiri_code']) ? $data['rahgiri_code'] : '';
		$this->Connect();
		$this->data['Calls']['get_status'] = $this->data['Proxy']->get_status($data['rahgiri_code']);
		if(isset($this->data['Calls']['get_status']->error_code)){
			$status = $this->data['Calls']['get_status']->error_message;
		} else {
			$status = $this->data['Calls']['get_status']->status_string."\n".$this->data['Calls']['get_status']->status_description;
		}
		return $status;
	}
}

?>